/* JCAB's Console Game
http://www.flipcode.com/cgi-bin/msg.cgi?showThread=Tip-Win32ConsoleAllocation&forum=totd&id=-1

JCAB's note:

"It's just a quickly-made test, so it has globals and such.
Not good design for a game in general.
I was just getting the minimum thing that works."

http://www.JCABs-Rumblings.com

---------------------------------------------------------------------

converted from C++ to ANSI C by Mike Caetano

*/

#include <windows.h>
#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>
#include <time.h>
#include <assert.h>

unsigned int currentScore = 0;

unsigned int width  = 0;

unsigned int height = 0;

char numbers[24][80];

HANDLE oh[2]    = {	NULL, NULL };

HANDLE ih       = NULL;


BOOL isRendering        = FALSE;

BOOL isCursorShowing    = TRUE;



void Swap(HANDLE h1, HANDLE h2)
{

	const HANDLE temp   = h1;

	h1                  = h2;

	h2                  = temp;

}



HANDLE CreateConsoleBuffer(UINT w, UINT h)
{

	HANDLE oh = CreateConsoleScreenBuffer(GENERIC_READ | GENERIC_WRITE
					, 0
					, NULL
					, CONSOLE_TEXTMODE_BUFFER
					, NULL);


	CONSOLE_SCREEN_BUFFER_INFO cbi;

	GetConsoleScreenBufferInfo(oh, &cbi);

	if ( (UINT)cbi.dwSize.X < width || (UINT)cbi.dwSize.Y < height) {

		COORD coord;

	   	coord.X = ( width > (UINT)cbi.dwSize.X ) ? width : (UINT)cbi.dwSize.X;
		coord.Y = ( height  > (UINT)cbi.dwSize.Y ) ? height: (UINT)cbi.dwSize.Y;

		SetConsoleScreenBufferSize(oh, coord);

	}

	COORD maxSize = GetLargestConsoleWindowSize(oh);

	static SMALL_RECT rect;

	rect.Left = 0;
	rect.Top = 0;
	rect.Right = ( width  < (UINT)maxSize.X ? width : (UINT)maxSize.X ) - 1;
	rect.Bottom = ( height < (UINT)maxSize.Y ? height : (UINT)maxSize.Y ) - 1;

	SetConsoleWindowInfo(oh, TRUE, &rect);


	static COORD coord;
   	coord.X = width;
	coord.Y = height;

	SetConsoleScreenBufferSize(oh, coord);

	return oh;

}



void InitializeScreen(const char *str, UINT w, UINT h)
{

	width   = w;

	height  = h;

	AllocConsole();


	SetConsoleTitle(str);


	oh[0] = CreateConsoleBuffer(w, h);

	oh[1] = CreateConsoleBuffer(w, h);

	SetConsoleActiveScreenBuffer(oh[1]);


	ih = GetStdHandle(STD_INPUT_HANDLE);

	SetConsoleMode(ih, 0);

}


void FinalizeScreen(void)
{

	width   = 0;

	height  = 0;


	CloseHandle(oh[0]);

	CloseHandle(oh[1]);

	CloseHandle(ih);


	oh[0]   = NULL;

	oh[1]   = NULL;

	ih      = NULL;


	FreeConsole();

}



void MyHideCursor(void)
{

	assert(oh[0] != NULL);


	const CONSOLE_CURSOR_INFO ci = { 100, FALSE };

	SetConsoleCursorInfo(oh[0], &ci);

	SetConsoleCursorInfo(oh[1], &ci);

	isCursorShowing = FALSE;

}



void MyShowCursor(void)
{

	assert(oh[0] != NULL);


	const CONSOLE_CURSOR_INFO ci = { 100, TRUE };

	SetConsoleCursorInfo(oh[0], &ci);

	SetConsoleCursorInfo(oh[1], &ci);

	isCursorShowing = TRUE;

}



void MySetCursor(UINT x, UINT y)
{

	assert(oh[0] != NULL);

	static COORD coord;
   	coord.X = x;
	coord.Y = y;

	SetConsoleCursorPosition(oh[0], coord);

	SetConsoleCursorPosition(oh[1], coord);

}



void BeginRenderingScreen(void)
{

	assert(oh[0] != NULL);

	if ( isCursorShowing ) {

		MyHideCursor();

		isCursorShowing = TRUE;

	}


	DWORD junk;

	const COORD zeroCoord = { 0, 0 };

	FillConsoleOutputCharacter(oh[0], ' ', width * height, zeroCoord, &junk);

	isRendering = TRUE;

}



void EndRenderingScreen(void)
{

	assert(isRendering);

	SetConsoleActiveScreenBuffer(oh[0]);

	if ( isCursorShowing ) {

		MyShowCursor();

	}

	Swap(oh[0], oh[1]);

	isRendering = FALSE;

}


void DrawString(const char *string)
{

	assert(isRendering);

	DWORD junk;

	WriteConsole(oh[0], string, strlen(string), &junk, 0);

}


void DrawStringAt(UINT x, UINT y, const char *string, UINT num = 0)
{

	assert(isRendering);

	DWORD junk;

	static COORD coord;
	coord.X = x;
	coord.Y = y;

	WriteConsoleOutputCharacter(oh[0]
		, string
		, ( num == 0 ? strlen(string): num )
		, coord
		, &junk);

}


char WaitKey(void)
{

	DWORD junk;

	char c;

	ReadConsole(ih, &c, 1, &junk, 0);

	return c;

}


char GetKey(void)
{
	return ( WaitForSingleObject(ih, 0) != WAIT_OBJECT_0 ? 0 : WaitKey() );
}


void DrawStatusLine(void)
{

	char s[256];

	sprintf(s, "Come (C) 2001 by Juan Carlos Arevalo-Baeza     Score:%4d     press H for help", currentScore);

	DrawStringAt(1, 24, s);

}


void DrawEndGameStatusLine(void)
{

	char s[256];

	sprintf(s, "Come (C) 2001          Final Score:%4d                  press P to play again", currentScore);

	DrawStringAt(1, 24, s);

}



void DrawInstructions(void)
{

	DrawStringAt(1, 10, "                                                         ");

	DrawStringAt(1, 11, "  press 1, 2, 3, 6, 9, 8, 7, 4 for directional movement  ");

	DrawStringAt(1, 12, "  press RETURN to exit                                   ");

	DrawStringAt(1, 13, "  press H to return to the game                          ");

	DrawStringAt(1, 14, "                                                         ");

}


void FillNumbers(void)
{

	for (int y = 0; y < 24; ++y) {

		for (int x = 0; x < 80; ++x) {

			numbers[y][x] = (rand() % 9) + '1';

		}

	}

}



void DrawBoard(void)
{
	for (int y = 0; y < 24; ++y) {

		DrawStringAt(0, y, numbers[y], 80);

	}

}



BOOL Move(UINT *x, UINT *y, int dx, int dy)
{

	*x += dx;

	*y += dy;

	if ( *x >= 80 || *y >= 25 ) {

		return TRUE;

	}

	static char xChar;

   	xChar = numbers[*y][*x];

	if ( xChar < '1' || xChar > '9' ) {

		return TRUE;

	}

	const UINT num = xChar - '0';

	for (UINT i = 0; i < num; ++i) {

   		char *nChar = &numbers[*y][*x];

		if ( *nChar < '1' || *nChar > '9' ) {

			return TRUE;

		}

		*nChar = ' ';

		MySetCursor(*x, *y);

		if ( i + 1 < num ) {

			*x += dx;

			*y += dy;

			if ( *x >= 80 || *y >= 25 ) {

				return TRUE;

			}

		}

		++currentScore;

	}

	return FALSE;

}



BOOL MoveDownLeft(UINT *x, UINT *y) {
	return Move(x, y, -1,  1);
}

BOOL MoveDown(UINT *x, UINT *y) {
	return Move(x, y,  0,  1);
}

BOOL MoveDownRight(UINT *x, UINT *y) {
	return Move(x, y,  1,  1);
}

BOOL MoveRight(UINT *x, UINT *y) {
	return Move(x, y,  1,  0);
}

BOOL MoveUpRight(UINT *x, UINT *y) {
	return Move(x, y,  1, -1);
}

BOOL MoveUp(UINT *x, UINT *y) {
	return Move(x, y,  0, -1);
}

BOOL MoveUpLeft(UINT *x, UINT *y) {
	return Move(x, y, -1, -1);
}

BOOL MoveLeft(UINT *x, UINT *y) {
	return Move(x, y, -1,  0);
}


void RunGame(void)
{

	MyShowCursor();

	FillNumbers();

	currentScore = 0;

	UINT posX = 40;

	UINT posY = 12;

	BOOL end = FALSE;

	while ( !end ) {

		BeginRenderingScreen();

		DrawBoard();

		DrawStatusLine();

		EndRenderingScreen();

		MySetCursor(posX, posY);

		switch (toupper(WaitKey())) {

		case 13:

			end = TRUE;

			break;

		case 'H':

			BeginRenderingScreen();

			DrawBoard();

			DrawStatusLine();

			DrawInstructions();

			EndRenderingScreen();

			while ( toupper(WaitKey()) != 'H' );  // do nothing

			break;

		case '1':

			end = MoveDownLeft(&posX, &posY);

			break;

		case '2':

			end = MoveDown(&posX, &posY);

			break;

		case '3':

			end = MoveDownRight(&posX, &posY);

			break;

		case '6':

			end = MoveRight(&posX, &posY);

			break;

		case '9':

			end = MoveUpRight(&posX, &posY);

			break;

		case '8':

			end = MoveUp(&posX, &posY);

			break;

		case '7':

			end = MoveUpLeft(&posX, &posY);

			break;

		case '4':

			end = MoveLeft(&posX, &posY);

			break;

		}

		Sleep(20);

	}

}



int APIENTRY WinMain(HINSTANCE hInstance,

	HINSTANCE hPrevInstance,

	LPSTR     lpCmdLine,

	int nCmdShow)

{


	srand((UINT)time(NULL));

	InitializeScreen("Come", 80, 25);

	BOOL end = FALSE;

	while ( !end ) {

		RunGame();

		BeginRenderingScreen();

		DrawBoard();

		DrawEndGameStatusLine();

		EndRenderingScreen();

		BOOL keyIsGood = FALSE;

		while ( !keyIsGood ) {

			switch (toupper(WaitKey())) {

			case 13:

				end = TRUE;

				keyIsGood = TRUE;

				break;

			case 'P':

				keyIsGood = TRUE;

				break;

			}

		}

	}

	FinalizeScreen();

	return 0;

}




